import 'package:tencent_cloud_chat_sdk/models/v2_tim_message_reaction.dart';

class V2TIMMessageReactionChangeInfo {
  late String messageID;
  late List<V2TimMessageReaction> reactionList;
  V2TIMMessageReactionChangeInfo({
    required this.messageID,
    required this.reactionList,
  });
  V2TIMMessageReactionChangeInfo.fromJson(Map<String, dynamic> json) {
    messageID = json['messageID'] ?? "";
    if (json['reactionList'] != null) {
      reactionList = List.empty(growable: true);
      json['reactionList'].forEach((v) {
        reactionList.add(V2TimMessageReaction.fromJson(v));
      });
    } else {
      reactionList = [];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['reactionID'] = messageID;

    data['reactionList'] = reactionList.map((v) => v.toJson()).toList();
    return data;
  }
}
