import 'package:tencent_cloud_chat_sdk/models/v2_tim_message_search_result_item.dart';

/// V2TimMessageSearchResult
///
/// {@category Models}
///
class V2TimMessageSearchResult {
  int? totalCount;
  List<V2TimMessageSearchResultItem>? messageSearchResultItems;
  String? searchCursor;
  V2TimMessageSearchResult({
    this.totalCount,
    this.messageSearchResultItems,
    this.searchCursor,
  });

  V2TimMessageSearchResult.fromJson(Map<String, dynamic> json) {
    totalCount = json['totalCount'];
    searchCursor = json["searchCursor"] ?? "";
    if (json['messageSearchResultItems'] != null) {
      messageSearchResultItems = List.empty(growable: true);
      json['messageSearchResultItems'].forEach((v) {
        messageSearchResultItems!.add(V2TimMessageSearchResultItem.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['totalCount'] = totalCount;
    data["searchCursor"] = searchCursor;
    if (messageSearchResultItems != null) {
      data['messageSearchResultItems'] = messageSearchResultItems!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

// {
//   "userID":"",
//   "timestamp":0
// }
